<?php

/**
 * This file contains some of the utils, changes we have done to the default php
 * 
 * This file must "always" be included
 */


// Send all PHP core messages to DEBUG log file...
function exceptions_error_handler($severity, $message, $filename = null, $lineno = null) {
        /*
    E_ERROR              => 'Error',
    E_WARNING            => 'Warning',
    E_PARSE              => 'Parsing Error',
    E_NOTICE             => 'Notice',
    E_CORE_ERROR         => 'Core Error',
    E_CORE_WARNING       => 'Core Warning',
    E_COMPILE_ERROR      => 'Compile Error',
    E_COMPILE_WARNING    => 'Compile Warning',
    E_USER_ERROR         => 'User Error',
    E_USER_WARNING       => 'User Warning',
    E_USER_NOTICE        => 'User Notice',
    E_STRICT             => 'Runtime Notice',
    E_RECOVERABLE_ERROR  => 'Catchable Fatal Error'
        */

	//throw new ErrorException($message, 0, $severity, $filename, $lineno);
	
	// Skip error with "It is not safe to rely on the system's timezone settings"
	if (strstr($message, "It is not safe to rely on the system's timezone settings")) return;

	// Remove first part of filename, since this will be wrong... (bcompiled)
	if (strstr($filename, 'src/')) {
		$filename = substr($filename, strrpos($filename, 'src/')+4); 
	}
	

	// Send error message to default log
	Logger::Debug("PHP-CORE", $filename . " - " . $message, $lineno);	
}


// Our own escape strings..
function escape_string($string) {
	return str_replace("\"", "\"\"", $string);
}


// PHP 2 JSON, since this is working as it should...
function php2js($a) {
	if (is_null($a)) return 'null';
	if ($a === false) return 'false';
	if ($a === true) return 'true';
	if (is_scalar($a)) {
		$a = addslashes($a);
		$a = str_replace("\n", '\n', $a);
		$a = str_replace("\r", '\r', $a);
		$a = preg_replace('{(</)(script)}i', "$1'+'$2", $a);
		return "'$a'";
	}
	$isList = true;
	for ($i=0, reset($a); $i<count($a); $i++, next($a))
	if (key($a) !== $i) { $isList = false; break; }
	$result = array();
	if ($isList) {
		foreach ($a as $v) $result[] = php2js($v);
		return '[ ' . join(', ', $result) . ' ]';
	} else {
		foreach ($a as $k=>$v)
		$result[] = php2js($k) . ': ' . php2js($v);
		return '{ ' . join(', ', $result) . ' }';
	}
}

?>